{
 Please read the read me file.
 This unit is based on a component of getfreesystemresources
 That I found on the Delphi Super page site
 Based on the work of Mark Pietrek
}
unit thunk;

interface

function GetThunkSum(num1 , num2: WORD): WORD;

implementation

uses SysUtils, Windows;

{ Undocumented Kernel32 calls. }
function LoadLibrary16(LibraryName: PChar): THandle; stdcall; external kernel32 index 35;
procedure FreeLibrary16(HInstance: THandle); stdcall; external kernel32 index 36;
function GetProcAddress16(Hinstance: THandle; ProcName: PChar): Pointer; stdcall; external kernel32 index 37;
procedure QT_Thunk; cdecl; external kernel32 name 'QT_Thunk';

{ Use global variables, so QT_Thunk does not trash them. }
var
  hInst16: THandle; {the handle to keep the library in}
  pFunc: Pointer; {pointer to the function}

{ QT_Thunk needs a stack frame. }
{$StackFrames On}

function GetThunkSum(num1, num2: WORD): WORD;
var
  ThunkTrash: array[0..$20] of Word;
begin
  { Prevent the optimizer from getting rid of ThunkTrash. }
  ThunkTrash[0] := hInst16;

  hInst16 := LoadLibrary16('DLL16.DLL');
  if hInst16 < 32 then
    raise Exception.Create('Cannot load DLL16.DLL');
  { Get the function pointer for the 16-bit function in USER.EXE. }
  pFunc := GetProcAddress16(hInst16, 'GetSum');
  if pFunc = nil then
    raise Exception.Create('Can not get address of GetPassword');

  asm
    push num1  { push argument 1 }
    push num2  { push argument 2 }
    mov edx, pFunc     { load 16-bit procedure pointer }
    call QT_Thunk     { call thunk }
    mov Result, ax    { save the result }
  end;
FreeLibrary16(hInst16);        {Free the library}
end;

end.

